SuperStrict

'import required modules
Framework brl.standardio
Import brl.retro
Import pine.BinTree

'create a new tree object
Local tree:BinTree=CreateTree()

help
Repeat
	Local c$=Lower(Input("Do what? "))
	If c="i" Or c="insert"
		Local val$=Input("Insert what value? ")
		Local key$=Input("Assign what key to it? ")
		TreeInsert tree,key,val
		Print "Inserted key,value pair ["+key+","+val+"]"
	ElseIf c="r" Or c="remove"
		Local key$=Input("Remove all values associated with what key? ")
		Local num%=TreeRemove(tree,key)
		Print " "+num+" values removed"
	ElseIf c="f" Or c="find"
		Local key$=Input("Find a value associated with what key? ")
		Local val$=String(TreeFind(tree,key))
		If val Then
			Print " Found: "+val
		Else
			Print " Found no values"
		EndIf
	ElseIf c="a" Or c="find all" Or c="all"
		Local key$=Input("Find all values associated with what key? ")
		Local vals:TList=TreeFindAll(tree,key)
		If ListIsEmpty(vals) Then
			Print " Found no values"
		Else
			For Local val$=EachIn vals
				Print " Found: "+val
			Next
		EndIf
	ElseIf c="o" Or c="output"
		Print "Contents of the tree:"
		If Not TreeIsEmpty(tree)
			For Local node:BinNode=EachIn TreeNodes(tree)
				Local r$="",p$="none",lr$=""
				If node=TreeRoot(tree) Then r=" << root"
				Print " "+node.key+": "+BinNodeString(node)+r
				If node.parent Then 
					p=node.parent.key
					lr=" : on its right>"
					If node.parent.l=node lr=" : on its <left"
				EndIf
				Print "   parent: "+p+lr
			Next
		Else
			Print " [nothing]"
		EndIf
	ElseIf c="v" Or c="values"
		Print "Values in the tree:"
		If Not TreeIsEmpty(tree)
			For Local s$=EachIn tree
				Print " "+s
			Next
		Else
			Print " [nothing]"
		EndIf
	ElseIf c="s" Or c="show"
		Local node:BinNode=TreeRoot(tree)
		Print " Root: "+node.key+": "+BinNodeString(node)
	ElseIf c="t" Or c="tell"
		Print " Height: "+TreeHeight(tree)
		Print " Count: "+CountTree(tree)
	ElseIf c="h" Or c="help"
		help
	ElseIf c="q" Or c="quit"
		Exit
	Else
		Print "You can't do that!"
	EndIf
Forever

Function help()
	Print "[i]nsert a new element into the tree"
	Print "[r]emove an existing element from the tree"
	Print "[f]ind the first value in the tree associated with some key"
	Print "find the [a]ll values in the tree associated with some key"
	Print "[o]utput the entire contents of the tree"
	Print "output all the [v]alues contained in the tree"
	Print "[s]how the root of the tree"
	Print "[t]ell the height and number of elements in the tree"
	Print "[h]elp"
	Print "[q]uit"
End Function